/* GCC */
#include <vector>
#include <iostream>
#include <sstream>

#define PB push_back

using namespace std;

struct person
{
       vector < char > name;
       bool m;
       int pair;
       vector < int > s;
};

person pers[40]; 
int pers_sz = 0;

int find( vector < char > name )
{
    for( int i = 0; i < pers_sz; i++ )
    {
         //if( name.size() != pers[i].name.size() ) continue;
         
         //int j = 0;
         //for( ; j < name.size(); j++ ) if( name[j] != pers[i].name[j] ) break;
         if( /*j == name.size()*/ name == pers[i].name ) return i;
    }
    return -1;
}

int main()
{
    freopen("family.in", "r", stdin);
    freopen("family.out", "w", stdout);
    
    for( int i = 0; i < 40; i++ )
    {
         pers[i].pair = -1;
    }
    
    char c;
    vector < char > first, second, first_name, second_name, word;
    
    c = ' ';
    while( c == ' ' ) c = getchar();
    while( ( c != ' ' ) && ( c != '\n' ) )
    {
           first.PB( c );
           c = getchar();
    }
    
    //for( int i = 0; i < first.size(); i++ ) cout << first[i];
    //cout << endl;
    
    c = ' ';
    while( ( c == ' ' ) || ( c == '\n' ) ) c = getchar();
    while( ( c != ' ' ) && ( c != '\n' ) )
    {
           second.PB( c );
           c = getchar();
    }
    
    pers[0].name = first;
    pers[1].name = second;
    pers_sz = 2;
    //for( int i = 0; i < second.size(); i++ ) cout << second[i];
    //cout << endl;
    
    while( c != '\n' ) c = getchar();
    
    while( scanf("%c", &c) != -1 )
    {
           first_name.resize(0);
           second_name.resize(0);
           word.resize(0);
           while( c == ' ' ) c = getchar();;
           while( ( c != ' ' ) && ( c != '\n' ) )
           {
                  first_name.PB( c );
                  c = getchar();
           }
           
           c = ' ';
           while( ( c == ' ' ) || ( c == '-' ) ) c = getchar();
           
           while( ( c != ' ' ) && ( c != '\n' ) )
           {
                  word.PB( c );
                  c = getchar();
           }
           
           c = ' ';
           while( ( c == ' ' ) || ( c == '-' ) ) c = getchar();
           
           while( ( c != ' ' ) && ( c != '\n' ) )
           {
                  second_name.PB( c );
                  c = getchar();
           }
           
           if( second_name[second_name.size() - 1] == '' ) second_name[second_name.size() - 1] = '';
           if( second_name[second_name.size() - 1] == '' ) second_name[second_name.size() - 1] = '';
           if( second_name[second_name.size() - 1] == '' ) second_name.resize( second_name.size() - 1 );
           
           int pos_f = find( first_name ), pos_s = find( second_name );
           if( pos_f == -1 ) pos_f = pers_sz, pers_sz++, pers[pos_f].name = first_name;
           if( pos_s == -1 ) pos_s = pers_sz, pers_sz++, pers[pos_s].name = second_name;
           
           
           if( word[1] == '' ) pers[pos_s].s.PB( pos_f ), pers[pos_f].m = 0;
           if( word[1] == '' ) pers[pos_s].s.PB( pos_f ), pers[pos_f].m = 1;
           if( word[1] == '' ) pers[pos_s].pair = pos_f, pers[pos_f].pair = pos_s, pers[pos_s].m = 0, pers[pos_f].m = 1;
           
           /*for( int i = 0; i < first_name.size(); i++ ) cout << first_name[i];
           cout << endl;
           for( int i = 0; i < word.size(); i++ ) cout << word[i];
           cout << endl;
           for( int i = 0; i < second_name.size(); i++ ) cout << second_name[i];
           cout << endl;
           */
           while( c != '\n' ) c = getchar();
    }
    
    int pos_f = find( first ), pos_s = find( second );
    
    for( int i = 0; i < pers_sz; i++ )
    {
         if( pers[i].pair == -1 ) continue;
         
         for( int j = 0; j < pers[pers[i].pair].s.size(); j++ ) pers[i].s.PB( pers[pers[i].pair].s[j] );
    }
    
    int j = 0;
    for( ; j < pers[pos_f].s.size(); j++ ) if( pers[pos_f].s[j] == pos_s ) break;
    if( j < pers[pos_f].s.size() )
    {
        if( pers[pos_s].name[pers[pos_s].name.size() - 1] == '' ) pers[pos_s].name[pers[pos_s].name.size() - 1] = ''; else
        if( pers[pos_s].name[pers[pos_s].name.size() - 1] == '' ) pers[pos_s].name[pers[pos_s].name.size() - 1] = ''; else
        if( pers[pos_s].name[pers[pos_s].name.size() - 1] == '' ) pers[pos_s].name[pers[pos_s].name.size() - 1] = ''; else pers[pos_s].name.PB( '' );
        if( pers[pos_f].m == 0 )
        {
            for( int i = 0; i < pers[pos_f].name.size(); i++ ) cout << pers[pos_f].name[i];
            cout << " -  ";
            for( int i = 0; i < pers[pos_s].name.size(); i++ ) cout << pers[pos_s].name[i];
            cout << endl;
        }
        else
        {
            for( int i = 0; i < pers[pos_f].name.size(); i++ ) cout << pers[pos_f].name[i];
            cout << " -  ";
            for( int i = 0; i < pers[pos_s].name.size(); i++ ) cout << pers[pos_s].name[i];
            cout << endl;
        }
    }
    
    j = 0;
    for( ; j < pers[pos_s].s.size(); j++ ) if( pers[pos_s].s[j] == pos_f ) break;
    if( j < pers[pos_s].s.size() )
    {
        if( pers[pos_f].name[pers[pos_f].name.size() - 1] == '' ) pers[pos_f].name[pers[pos_f].name.size() - 1] = ''; else
        if( pers[pos_f].name[pers[pos_f].name.size() - 1] == '' ) pers[pos_f].name[pers[pos_f].name.size() - 1] = ''; else
        if( pers[pos_f].name[pers[pos_f].name.size() - 1] == '' ) pers[pos_f].name[pers[pos_f].name.size() - 1] = ''; else pers[pos_f].name.PB( '' );
        if( pers[pos_s].m == 0 )
        {
            for( int i = 0; i < pers[pos_s].name.size(); i++ ) cout << pers[pos_s].name[i];
            cout << " -  ";
            for( int i = 0; i < pers[pos_f].name.size(); i++ ) cout << pers[pos_f].name[i];
            cout << endl; 
        }
        else
        {
            for( int i = 0; i < pers[pos_s].name.size(); i++ ) cout << pers[pos_s].name[i];
            cout << " -  ";
            for( int i = 0; i < pers[pos_f].name.size(); i++ ) cout << pers[pos_f].name[i];
            cout << endl;
        }
    }
    
    fclose(stdin);
    fclose(stdout);
    return 0;
}
