/* GCC */
#include <iostream>
#include <cstdio>
#include <map>
#include <vector>
#include <string>
#include <queue>

using namespace std;

map<string , bool> sex;
map<string , vector<pair<string , string> > > Graph;
string Start , Finish , v , u , relative , buf;

void Change1(string &s)
{
      if ( s[s.size() - 1] == '' )  s[s.size() - 1] = ''; else
      if ( s[s.size() - 1] == '' )  s[s.size() - 1] = ''; else
        s.erase(s.size() - 1 , 1);
};

void Change2(string &s)
{
  if ( s == "" ) s += ''; else
  if ( s[s.size() - 1] == '' ) s[s.size() - 1] = '' ; else
  if ( s[s.size() - 1] == '' ) s[s.size() - 1] = '' ; else
  if ( s[s.size() - 1] == '' ) s[s.size() - 1] = '' ; else
  s += '';
};

string inverse(string s , bool sex)
{
  if ( s == "" ) return "";
  if ( sex ) return "";
  else return "";
};

vector <string> Rel;

void MakePath(string u , string v)
{
    map<string , int> Distance;
    map<string , pair<string , string> > Parent;
    queue <string> Q;
    Q.push(u);
    while ( !Q.empty() )
    {
        string q = Q.front();
        Q.pop();
        for (int i = 0 ; i < Graph[q].size() ; i ++ )
        {
          string to = Graph[q][i].second;
          if ( Distance.find(to) == Distance.end() || Distance[to] > Distance[q] + 1 )
          {
            Distance[to] = Distance[q] + 1;
            Parent[to] = make_pair(q , Graph[q][i].first);
            Q.push(to);
          };
        };
    };
    for (string i = v ; i != u ; i = Parent[i].first)
    {
      Rel.push_back(Parent[i].second);
    };
};

int main()
{
    freopen("family.in","r",stdin);
    freopen("family.out","w",stdout);
    cin >> Start >> Finish;
    while ( cin >> v >> buf >> relative >> u )
    {
      if ( relative == "" )
            sex[v] = false;
      if ( relative == "" )
            sex[v] = true;
      if ( relative == "" )
            sex[v] = true , sex[u] = false;

      Change1(u);
      Graph[v].push_back(make_pair(relative , u));
      Graph[u].push_back(make_pair(inverse(relative , sex[u]) , v));
    };

    MakePath(Start , Finish);

    while ( Rel.size() != 1 )
    {
        string Rel1 = Rel[Rel.size() - 1];
        string Rel2 = Rel[Rel.size() - 2];
        Rel.pop_back();
        if ( Rel1 == "" && (Rel2 == "" || Rel2 == "") )
            Rel.back() = ""; else

        if ( Rel1 == "" && (Rel2 == "" || Rel2 == "") )
            Rel.back() = "";  else

        if ( Rel1 == "" && (Rel2 == "" || Rel2 == "") )
            Rel.back() = ""; else

        if ( Rel1 == "" && (Rel2 == "" || Rel2 == "") )
            Rel.back() = ""; else

        if ( (Rel1 == "" || Rel1 == "")  && (Rel2 == "" || Rel2 == "") )
            Rel.back() = Rel1; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel2 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = ""; else

        if (Rel1 == "" && Rel2 == "")
            Rel.back() = "";
    };

    Change2(Finish);
    cout << Start << " - " << Rel[0] << " " << Finish << endl;
    return 0;
}
