/* GCC */

#include <fstream>
#include <vector>

int main()
{
    std::ifstream in("subseq.in");
    int n1;
    in >> n1;
    std::vector<int> s1(n1);
    for(int i = 0;i < s1.size();i++)
        in >> s1[i];
    int n2;
    in >> n2;
    std::vector<int> s2(n2);
    for(int i = 0;i < s2.size();i++)
        in >> s2[i];
    in.close();
    std::vector<std::vector<int> > table(2,std::vector<int>(s2.size()+1));
    int i;
    for(i = 1;i <= n1;i++)
    {
        for(int j = 1;j < table[i%2].size();j++)
        {
            if(s1[i-1] == s2[j-1])
                table[i%2][j] = 1 + table[(i-1+2)%2][j-1];
            else
                table[i%2][j] = std::max(table[(i-1+2)%2][j],table[i%2][j-1]);
        }
    }
    std::ofstream out("subseq.out");
    out << table[(i-1)%2].back() << std::endl;
    out.close();
}
